import React, { Component } from 'react';
import logo from './logo.svg';
import './App.css';
import {connect} from 'react-redux';
import {bindActionCreators} from 'redux';

import {updateUser} from './actions/user-actions';

class App extends Component {
	
	constructor(props){
		super(props);
		this.onUpdateUser = this.onUpdateUser.bind(this);
	}
	
	onUpdateUser(){
		this.props.onUpdateUser('summary');
	}
	
  render() {
	  
	  console.log(this.props);
	  
    return (
      <div className="App">
        <header className="App-header">
          <img src={logo} className="App-logo" alt="logo" />
          <h1 className="App-title">Welcome to React</h1>
        </header>
        <p className="App-intro">
          To get started, edit <code>src/App.js</code> and save to reload.
        </p>
		
		<div onClick={this.onUpdateUser}>
			Update User
		</div>
		
		<div>{this.props.user}</div>
		
      </div>
    );
  }
}

/** All state mapping
const mapStateToProps = state => {
	return state;
}*/

/**
* Specific state mapping
*/
/*
const mapStateToProps = state => ({
	products: state.products,
	user: state.user
});
*/

/**
* mapping with external attributes props
*/
const mapStateToProps = (state, props) => {
	return {
		products: state.products,
		user: state.user,
		myNewProp: `${state.products} ${state.user}`
	}
}

/**
*Binding actions to props
*/
/*
const mapActionsToProps = {
	onUpdateUser: updateUser
};
*/

/**
* binding props to action
*/
const mapActionsToProps = (dispatch, props) => {
	
	return bindActionCreators({
		onUpdateUser: updateUser		
	}, dispatch);
};

const mergeProps = (propsFromState, propsFromDispatch, ownProps) => {
	console.log("***");
	console.log(propsFromState);
	console.log(propsFromDispatch);
	console.log(ownProps);
	
	return {};
}

export default connect(mapStateToProps, mapActionsToProps, mergeProps)(App);
