//MyApp.js

import React, {Component} from 'react';
import {connect} from 'react-redux';
import * as contactAction from './actions/contactAction'

class MyApp extends Component {

	constructor(props){
		super(props);
		this.handleSubmit = this.handleSubmit.bind(this);
		this.handleChange = this.handleChange.bind(this);		
		this.state = {
			name: ''
		};
	}

	handleSubmit(e){
		e.preventDefault();
		let contact= {
			name: this.state.name
		}

		this.setState({
			name: ''
		})

		this.props.createContact(contact);
	}


	handleChange(e){
		e.preventDefault();
		this.setState({
			name: e.target.value
		})
	}

	deleteContact(e, idx){
		e.preventDefault();

		this.props.deleteContact(idx);
	}

	listView(data, idx) {

		return (
				<div>
					<span>
						<li key={idx}>{data.name}</li>
					</span>

					<span>
						<button onClick={(e)=>this.deleteContact(e, idx)}>Remove</button>
					</span>
				</div>
			)
	}

	render(){

		console.log(this.props);

		return (
			<div className="container">
				<h1>Client Contact Application</h1>
				<hr />
				<div>
					<h3>Add Contact Form</h3>

					<form onSubmit={this.handleSubmit}>
						<input type="text" value={this.state.name} onChange={this.handleChange}/>
						<input type="submit" className="btn btn-success" value="ADD" />
					</form>

					{	
						<ul>
							{this.props.contacts.map((contact, i) => this.listView(contact, i))}
						</ul>
					}
				</div>
			</div>
			)
	}

}

const mapStateToProps = (state, ownProps) =>{
	return {
		contacts: state.contacts
	}
} 

const mapDispatchToProps = (dispatch) => {
	return {
		createContact: contact => dispatch(contactAction.createContact(contact)),
		deleteContact: idx => dispatch(contactAction.deleteContact(idx))
	}
}

export default connect(mapStateToProps, mapDispatchToProps)(MyApp);